VehicleFruitHud = {};
VehicleFruitHud.modDir = g_currentModDirectory;
VehicleFruitHud.settingsDir = getUserProfileAppPath().. "modSettings/VehicleFruitHud/";
VehicleFruitHud.metadata = {
	interface = " FS22 ...",
	title = "VehicleFruit Hud",
	notes = " setzt Name/Kapazität und ... zusätzlich ins VehicleFruit Hud",
	author = " (by HappyLooser)",
	version = " v0.66 Beta",	
	datum = " 20.11.2018",
	update = " 15.05.2023",
	web = " http://modhoster.de",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe: http://modhoster.de"
};

function VehicleFruitHud:loadMap(name)	
	print("---loading ".. tostring(VehicleFruitHud.metadata.title).. tostring(VehicleFruitHud.metadata.version).. tostring(VehicleFruitHud.metadata.author).. "---")
	if VehicleFruitHud:getServer() then return;end;
	VehicleFruitHud.hlDebugMode = false;
	loadScripts(1);			
	VehicleFruitHud.clickAreas = {master={}, slave={}};
	VehicleFruitHud.overlays = {};
	VehicleFruitHud:loadSettings();		
	loadScripts(2);
	Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, VehicleFruitHud.onStartMission);
end;

function VehicleFruitHud:onStartMission()	
	if not VehicleFruitHud:getServer() then 
		VehicleFruitHud:searchOtherMods();
		vfHlGui:generate(false);		
		--if VehicleFruitHud.values.foundMoh then vfSetGetForMoh:loadPdaIcons();vfSetGetForMoh:loadCmds();end;
		VehicleFruitHud:registerActionEventsPlayer();
		FSBaseMission.registerActionEvents = Utils.appendedFunction(FSBaseMission.registerActionEvents, VehicleFruitHud.registerActionEventsPlayer);
	end;
end;

function VehicleFruitHud:registerActionEventsPlayer()    
	local isOkay, eventName = InputBinding.registerActionEvent(g_inputBinding, 'VFOnOffMouseCursor', self, VehicleFruitHud.actionKeyMouse ,false ,true ,false ,true);
    if isOkay then if g_currentMission.hl.controlMod == "VehicleFruitHud" then g_inputBinding.events[eventName].displayIsVisible = false;else g_inputBinding:removeActionEvent(eventName);end;end;	
end;

function VehicleFruitHud:actionKeyMouse(actionName, keyStatus, arg4, arg5, arg6)	
	if not g_currentMission.hl.dragDrop.on then
		if not VehicleFruitHud.values.isOn and actionName == "VFOnOffMouseCursor" then 
			vfMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, true, true); 
		elseif actionName == "VFOnOffMouseCursor" then
			vfMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, false, true);		
		end;
	end;
end;

function VehicleFruitHud:deleteMap()
	if VehicleFruitHud:getServer() then return;end;
	VehicleFruitHud:saveSettings();	
end;

function VehicleFruitHud:mouseEvent(posX, posY, isDown, isUp, button)
	if VehicleFruitHud:getServer() or VehicleFruitHud:get_hl("getIngameMap", {}, "getIngameMap") or VehicleFruitHud:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	if VehicleFruitHud.values.isOn then vfMouseKeyEvents:setKeyMouse(nil, nil, nil, nil, posX, posY, isDown, isUp, button);end;
end;

function VehicleFruitHud:keyEvent(unicode, sym, modifier, isDown)	
	if VehicleFruitHud:getServer() or VehicleFruitHud:get_hl("getIngameMap", {}, "getIngameMap") or VehicleFruitHud:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	if VehicleFruitHud.values.isOn then vfMouseKeyEvents:setKeyMouse(unicode, sym, modifier, isDown, nil, nil, nil, nil, nil);end;	
end;

function VehicleFruitHud:update(dt)	
	if VehicleFruitHud:getServer() or VehicleFruitHud:get_hl("getIngameMap", {}, "getIngameMap") or VehicleFruitHud:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	g_currentMission.hl.update(dt, "VehicleFruitHud");
	if VehicleFruitHud.values.firstStartVersion then VehicleFruitHud.values.firstStartVersion = false;vfSetGet:infoTxt();end;	
end;

function VehicleFruitHud:draw(dt)	
	if VehicleFruitHud:getServer() or VehicleFruitHud:get_hl("getIngameMap", {}, "getIngameMap") or VehicleFruitHud:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;	
	g_currentMission.hl.draw("VehicleFruitHud");	
	
	--respect settings for other mods (not every mod) that's why
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
	if VehicleFruitHud.values.isOn then
		local isControlled = g_currentMission.controlledVehicle;
		local foundHorse = false;
		if VehicleFruitHud.values.viewHorseHud ~= nil and isControlled and isControlled.spec_rideable ~= nil then
			foundHorse = true;
			vfDraw:setOpen(isControlled, vfSetGet:getSpeed(isControlled));			
		end;
		if not foundHorse then
			local display = g_currentMission.hud.fillLevelsDisplay;
			if display:getVisible() and display.vehicle ~= nil and g_currentMission.hud.showVehicleSchema and isControlled and display.vehicle == isControlled then
				if display.fillLevelBuffer ~= nil and type(display.fillLevelBuffer) == "table" and #display.fillLevelBuffer > 0 then vfDraw:setFillLevelsDisplay(display);end;
			end;
		end;	
	end;
	if #VehicleFruitHud.values.testString > 0 then
		setTextBold(true);		
		for a=1, #VehicleFruitHud.values.testString do
			local posY = 0.25-(a/100);
			renderText(0.5, posY, 0.010, "-S ".. tostring(a).. "- ".. tostring(VehicleFruitHud.values.testString[a]));
		end;
	end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;

function loadScripts(int)
	if int == 1 then
		source(VehicleFruitHud.modDir.."_hl.lua");
		source(VehicleFruitHud.modDir.."defaultSettings/vfLoadTables.lua");
		source(VehicleFruitHud.modDir.."scripte/vfSetGet.lua");
		source(VehicleFruitHud.modDir.."defaultSettings/vfSetGetSettingsXml.lua");		
	end;
	if int == 2 then
		--source(VehicleFruitHud.modDir.."scripte/overlays/vfSetGetOverlays.lua");
		source(VehicleFruitHud.modDir.."scripte/mouseKeyEvents/vfMouseKeyEvents.lua");
		source(VehicleFruitHud.modDir.."scripte/hlGui/vfHlGui.lua");		
		source(VehicleFruitHud.modDir.."scripte/draw/vfDraw.lua");
		source(VehicleFruitHud.modDir.."scripte/mohFeatures/vfSetGetForMoh.lua");
	end;
end;

function VehicleFruitHud:searchOtherMods()	
	local env = getfenv(0);		
	if env["MultiOverlayV4"] ~= nil and env["MultiOverlayV4"] ~= nil then
		VehicleFruitHud.moh = env["MultiOverlayV4"];		
	end;
	if g_currentMission.multiOverlayV4 ~= nil then VehicleFruitHud.values.foundMoh = true;end;
end;

function VehicleFruitHud:saveSettings()
	vfSetGetSettingsXml:saveConfig();	
end;

function VehicleFruitHud:loadSettings()
	vfSetGetSettingsXml:loadConfig();	
end;

function VehicleFruitHud:getServer()	
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer ~= nil;	
end;

--_hl Freeware ls17,19,22--
function VehicleFruitHud:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if VehicleFruitHud.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" or g_currentMission.hl[args] ~= nil or #argsTable > 0 then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if VehicleFruitHud.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if VehicleFruitHud.hlDebugMode and (not isOkay or foundArgsError) then g_currentMission.hl.setDebug("VehicleFruitHudMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;
--_hl Freeware ls17,19,22--
addModEventListener(VehicleFruitHud);